## tinycbor 0.6.0

=== Makefile ===
# Variables:
prefix = /usr/local
exec_prefix = $(prefix)
bindir = $(exec_prefix)/bin
libdir = $(exec_prefix)/lib
includedir = $(prefix)/include
pkgconfigdir = $(libdir)/pkgconfig

CFLAGS = -Wall -Wextra
LDFLAGS_GCSECTIONS = -Wl,--gc-sections
LDFLAGS += $(if $(gc_sections-pass),$(LDFLAGS_GCSECTIONS))
LDLIBS = -lm

GIT_ARCHIVE = git archive --prefix="$(PACKAGE)/" -9
INSTALL = install
INSTALL_DATA = $(INSTALL) -m 644
INSTALL_PROGRAM = $(INSTALL) -m 755
QMAKE = qmake
MKDIR = mkdir -p
RMDIR = rmdir
SED = sed

# Our sources
TINYCBOR_HEADERS = src/cbor.h src/cborjson.h src/tinycbor-version.h
TINYCBOR_FREESTANDING_SOURCES = \
	src/cborerrorstrings.c \
	src/cborencoder.c \
	src/cborencoder_close_container_checked.c \
	src/cborencoder_float.c \
	src/cborparser.c \
	src/cborparser_float.c \
	src/cborpretty.c \
#
CBORDUMP_SOURCES = tools/cbordump/cbordump.c

BUILD_SHARED = $(shell file -L /bin/sh 2>/dev/null | grep -q ELF && echo 1)
BUILD_STATIC = 1

ifneq ($(BUILD_STATIC),1)
ifneq ($(BUILD_SHARED),1)
  $(error error: BUILD_STATIC and BUILD_SHARED can not be both disabled)
endif
endif

INSTALL_TARGETS += $(bindir)/cbordump
ifeq ($(BUILD_SHARED),1)
BINLIBRARY=lib/libtinycbor.so
INSTALL_TARGETS += $(libdir)/libtinycbor.so.$(VERSION)
endif
ifeq ($(BUILD_STATIC),1)
BINLIBRARY=lib/libtinycbor.a
INSTALL_TARGETS += $(libdir)/libtinycbor.a
endif
INSTALL_TARGETS += $(pkgconfigdir)/tinycbor.pc
INSTALL_TARGETS += $(TINYCBOR_HEADERS:src/%=$(includedir)/tinycbor/%)

# setup VPATH
MAKEFILE := $(lastword $(MAKEFILE_LIST))
SRCDIR := $(dir $(MAKEFILE))
VPATH = $(SRCDIR):$(SRCDIR)/src

# Our version
GIT_DIR := $(strip $(shell git -C $(SRCDIR). rev-parse --git-dir 2> /dev/null))
VERSION = $(shell cat $(SRCDIR)VERSION)
SOVERSION = $(shell cut -f1-2 -d. $(SRCDIR)VERSION)
PACKAGE = tinycbor-$(VERSION)

# Check that QMAKE is Qt 5
ifeq ($(origin QMAKE),file)
  check_qmake = $(strip $(shell $(1) -query QT_VERSION 2>/dev/null | cut -b1))
  ifneq ($(call check_qmake,$(QMAKE)),5)
    QMAKE := qmake -qt5
    ifneq ($(call check_qmake,$(QMAKE)),5)
      QMAKE := qmake-qt5
      ifneq ($(call check_qmake,$(QMAKE)),5)
        QMAKE := @echo >&2 $(MAKEFILE): Cannot find a Qt 5 qmake; false
      endif
    endif
  endif
endif

-include .config

ifeq ($(wildcard .config),)
    $(info .config file not yet created)
endif

ifeq ($(freestanding-pass),1)
TINYCBOR_SOURCES = $(TINYCBOR_FREESTANDING_SOURCES)
else
TINYCBOR_SOURCES = \
	$(TINYCBOR_FREESTANDING_SOURCES) \
	src/cborparser_dup_string.c \
	src/cborpretty_stdio.c \
	src/cbortojson.c \
	src/cborvalidation.c \
#
# if open_memstream is unavailable on the system, try to implement our own
# version using funopen or fopencookie
ifeq ($(open_memstream-pass),)
  ifeq ($(funopen-pass)$(fopencookie-pass),)
    CFLAGS += -DWITHOUT_OPEN_MEMSTREAM
    ifeq ($(wildcard .config),.config)
        $(warning warning: funopen and fopencookie unavailable, open_memstream can not be implemented and conversion to JSON will not work properly!)
    endif
  else
    TINYCBOR_SOURCES += src/open_memstream.c
  endif
endif
endif

# json2cbor depends on an external library (cjson)
ifneq ($(cjson-pass)$(system-cjson-pass),)
  JSON2CBOR_SOURCES = tools/json2cbor/json2cbor.c
  INSTALL_TARGETS += $(bindir)/json2cbor
  ifeq ($(system-cjson-pass),1)
    LDFLAGS_CJSON = -lcjson
  else
    JSON2CBOR_SOURCES += src/cjson/cJSON.c
    json2cbor_CCFLAGS = -I$(SRCDIR)src/cjson
  endif
endif

# Rules
all: .config \
	$(if $(subst 0,,$(BUILD_STATIC)),lib/libtinycbor.a) \
	$(if $(subst 0,,$(BUILD_SHARED)),lib/libtinycbor.so) \
	$(if $(freestanding-pass),,bin/cbordump) \
	tinycbor.pc
all: $(if $(JSON2CBOR_SOURCES),bin/json2cbor)
check: tests/Makefile | $(BINLIBRARY)
	$(MAKE) -C tests check
silentcheck: | $(BINLIBRARY)
	TESTARGS=-silent $(MAKE) -f $(MAKEFILE) -s check
configure: .config
.config: Makefile.configure
	$(MAKE) -f $(SRCDIR)Makefile.configure OUT='>&9' configure 9> $@

lib/libtinycbor-freestanding.a: $(TINYCBOR_FREESTANDING_SOURCES:.c=.o)
	@$(MKDIR) -p lib
	$(AR) cqs $@ $^

lib/libtinycbor.a: $(TINYCBOR_SOURCES:.c=.o)
	@$(MKDIR) -p lib
	$(AR) cqs $@ $^

lib/libtinycbor.so: $(TINYCBOR_SOURCES:.c=.pic.o)
	@$(MKDIR) -p lib
	$(CC) -shared -Wl,-soname,libtinycbor.so.$(SOVERSION) -o lib/libtinycbor.so.$(VERSION) $(LDFLAGS) $^ $(LDLIBS)
	cd lib ; ln -sf libtinycbor.so.$(VERSION) libtinycbor.so ; ln -sf libtinycbor.so.$(VERSION) libtinycbor.so.$(SOVERSION)

bin/cbordump: $(CBORDUMP_SOURCES:.c=.o) $(BINLIBRARY)
	@$(MKDIR) -p bin
	$(CC) -o $@ $(LDFLAGS) $^ $(LDLIBS)

bin/json2cbor: $(JSON2CBOR_SOURCES:.c=.o) $(BINLIBRARY)
	@$(MKDIR) -p bin
	$(CC) -o $@ $(LDFLAGS) $^ $(LDFLAGS_CJSON) $(LDLIBS)

tinycbor.pc: tinycbor.pc.in
	$(SED) > $@ < $< \
		-e 's,@prefix@,$(prefix),' \
		-e 's,@exec_prefix@,$(exec_prefix),' \
		-e 's,@libdir@,$(libdir),' \
		-e 's,@includedir@,$(includedir),' \
		-e 's,@version@,$(VERSION),'

tests/Makefile: tests/tests.pro
	$(QMAKE) $(QMAKEFLAGS) -o $@ $<

$(PACKAGE).tar.gz: | .git
	GIT_DIR=$(SRCDIR).git $(GIT_ARCHIVE) --format=tar.gz -o "$(PACKAGE).tar.gz" HEAD
$(PACKAGE).zip: | .git
	GIT_DIR=$(SRCDIR).git $(GIT_ARCHIVE) --format=zip -o "$(PACKAGE).zip" HEAD

$(DESTDIR)$(libdir)/%: lib/%
	$(INSTALL) -d $(@D)
	$(INSTALL_DATA) $< $@
$(DESTDIR)$(bindir)/%: bin/%
	$(INSTALL) -d $(@D)
	$(INSTALL_PROGRAM) $< $@
$(DESTDIR)$(pkgconfigdir)/%: %
	$(INSTALL) -d $(@D)
	$(INSTALL_DATA) $< $@
$(DESTDIR)$(includedir)/tinycbor/%: src/%
	$(INSTALL) -d $(@D)
	$(INSTALL_DATA) $< $@

install-strip:
	$(MAKE) -f $(MAKEFILE) INSTALL_PROGRAM='$(INSTALL_PROGRAM) -s' install

install: $(INSTALL_TARGETS:%=$(DESTDIR)%)
ifeq ($(BUILD_SHARED),1)
	ln -sf libtinycbor.so.$(VERSION) $(DESTDIR)$(libdir)/libtinycbor.so
	ln -sf libtinycbor.so.$(VERSION) $(DESTDIR)$(libdir)/libtinycbor.so.$(SOVERSION)
endif

uninstall:
	$(RM) $(INSTALL_TARGETS:%=$(DESTDIR)%)
	$(RM) $(DESTDIR)$(libdir)/libtinycbor.so
	$(RM) $(DESTDIR)$(libdir)/libtinycbor.so.$(SOVERSION)

mostlyclean:
	$(RM) $(TINYCBOR_SOURCES:.c=.o)
	$(RM) $(TINYCBOR_SOURCES:.c=.pic.o)
	$(RM) $(CBORDUMP_SOURCES:.c=.o)

clean: mostlyclean
	$(RM) bin/cbordump
	$(RM) bin/json2cbor
	$(RM) lib/libtinycbor.a
	$(RM) lib/libtinycbor-freestanding.a
	$(RM) tinycbor.pc
	$(RM) lib/libtinycbor.so*
	test -e tests/Makefile && $(MAKE) -C tests clean || :

distclean: clean
	test -e tests/Makefile && $(MAKE) -C tests distclean || :

docs:
	cd $(SRCDIR)src && VERSION=$(VERSION) doxygen $(SRCDIR)/../Doxyfile

dist: $(PACKAGE).tar.gz $(PACKAGE).zip
distcheck: .git
	-$(RM) -r $${TMPDIR-/tmp}/tinycbor-distcheck
	GIT_DIR=$(SRCDIR).git git archive --prefix=tinycbor-distcheck/ --format=tar HEAD | tar -xf - -C $${TMPDIR-/tmp}
	cd $${TMPDIR-/tmp}/tinycbor-distcheck && $(MAKE) silentcheck
	$(RM) -r $${TMPDIR-/tmp}/tinycbor-distcheck

tag: distcheck
	@cd $(SRCDIR). && perl scripts/maketag.pl

.PHONY: all check silentcheck configure install uninstall
.PHONY: mostlyclean clean distclean
.PHONY: docs dist distcheck release
.SECONDARY:

cflags := $(CPPFLAGS) -I$(SRCDIR)src
cflags += -std=gnu99 $(CFLAGS) \
	-Werror=incompatible-pointer-types \
	-Werror=implicit-function-declaration \
	-Werror=int-conversion
%.o: %.c
	@test -d $(@D) || $(MKDIR) $(@D)
	$(CC) $(cflags) $($(basename $(notdir $@))_CCFLAGS) -c -o $@ $<
%.pic.o: %.c
	@test -d $(@D) || $(MKDIR) $(@D)
	$(CC) $(cflags) -fPIC $($(basename $(notdir $@))_CCFLAGS) -c -o $@ $<

-include src/*.d

=== debian/changelog ===
tinycbor (0.6.0-2) unstable; urgency=medium

  * d/control: use my d.o email address
  * Rename json2cbor to tinycbor-json2cbor to avoid name conflict
    (closes: #1095717)
  * d/watch: change to correct repo url

 -- Shengqi Chen <harry@debian.org>  Wed, 12 Feb 2025 15:14:07 +0800

tinycbor (0.6.0-1) unstable; urgency=medium

  [ Shengqi Chen ]
  * New upstream version 0.6.0 (closes: #1085433)

 -- Shengqi Chen <harry-chen@outlook.com>  Sun, 20 Oct 2024 00:41:00 +0800

=== debian/control ===
Source: tinycbor
Section: utils
Priority: optional
Standards-Version: 4.7.0
Maintainer: Shengqi Chen <harry@debian.org>
Build-Depends:
 debhelper-compat (= 13),
 dh-exec,
 doxygen,
 graphviz,
 help2man,
 libcjson-dev,
 qtbase5-dev
Homepage: https://github.com/intel/tinycbor
Vcs-Git: https://salsa.debian.org/harry/tinycbor.git
Vcs-Browser: https://salsa.debian.org/harry/tinycbor
Rules-Requires-Root: no

Package: libtinycbor0.6
Section: libs
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}
Suggests: tinycbor-utils
Description: Concise Binary Object Representation (CBOR) library
 TinyCBOR library is a small CBOR encoder and decoder library,
 optimized for very fast operation with very small footprint.
 The main encoder and decoder functions do not allocate memory.
 .
 This package contains libtinycbor shared library.

Package: libtinycbor-dev
Section: libdevel
Architecture: any
Depends: ${misc:Depends}, libtinycbor0.6 (= ${binary:Version})
Description: Concise Binary Object Representation (CBOR) library (development files)
 TinyCBOR library is a small CBOR encoder and decoder library,
 optimized for very fast operation with very small footprint.
 The main encoder and decoder functions do not allocate memory.
 .
 This package contains development files for libtinycbor.

Package: tinycbor-utils
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}, libtinycbor0.6 (= ${binary:Version})
Description: Concise Binary Object Representation (CBOR) library (utilities)
 TinyCBOR library is a small CBOR encoder and decoder library,
 optimized for very fast operation with very small footprint.
 The main encoder and decoder functions do not allocate memory.
 .
 This package contains some utilities for CBOR files.

=== debian/rules ===
#!/usr/bin/make -f

export DEB_BUILD_MAINT_OPTIONS = hardening=+all
DPKG_EXPORT_BUILDFLAGS = 1

include /usr/share/dpkg/buildflags.mk
include /usr/share/dpkg/pkg-info.mk

TARGET_DIR = $(CURDIR)/debian/tmp/usr
TARGET_LIBDIR = $(TARGET_DIR)/lib/$(DEB_HOST_MULTIARCH)

%:
	dh $@

override_dh_auto_clean:
	$(MAKE) clean
	rm -f .config

override_dh_auto_configure:

override_dh_auto_build:
	$(MAKE) CFLAGS="$(CFLAGS)" CPPFLAGS="$(CPPFLAGS)" LDFLAGS="$(LDFLAGS)"
	$(MAKE) docs

override_dh_auto_test:
ifeq (,$(filter, nocheck,$(DEB_BUILD_OPTIONS)))
	@echo 'blhc: ignore-line-regexp: .*(qt|Qt).*'
	$(MAKE) check
endif

override_dh_auto_install:
	$(MAKE) install prefix=$(TARGET_DIR) libdir=$(TARGET_LIBDIR)

execute_after_dh_auto_build:
	help2man --version-string=$(DEB_VERSION_UPSTREAM) --name="tinycbor Concise Binary Object Representation (CBOR) library" -N -o cbordump.1 bin/cbordump
	help2man --version-string=$(DEB_VERSION_UPSTREAM) --name="tinycbor Concise Binary Object Representation (CBOR) library" -N -o tinycbor-json2cbor.1 bin/json2cbor

=== debian/tests/control ===
Tests: upstream-test-suite
Restrictions: allow-stderr
Depends: @, build-essential, qtbase5-dev

=== debian/watch ===
version=4
https://github.com/intel/tinycbor/tags .*/v?(\d.*)@ARCHIVE_EXT@

## tinycbor 0.6.0+git20250214.53ff130

=== debian/changelog ===
tinycbor (0.6.0+git20250214.53ff130-2) unstable; urgency=medium

  * d/patches:
    + disable more flaky tests on non-amd64 architectures.
    + add patch that checks SSE2 availability to fix FTBFS on i386.
  * d/tests:
    + refresh and move patch to d/patches.
    + try using qt6 to build first, then fallback to qt5.

 -- Shengqi Chen <harry@debian.org>  Wed, 26 Feb 2025 15:23:03 +0800

tinycbor (0.6.0+git20250214.53ff130-1) unstable; urgency=medium

  * d/rules: ignore test files from blhc
  * d/control:
    + bump std-ver to 4.7.1 (no changes required)
    + mark libtinycbor{0.6,-dev} as Multi-Arch: same
  * Move libtinycbor-dev.doc-base to the correct location
  * New upstream version 0.6.0+git20250214.53ff130

 -- Shengqi Chen <harry@debian.org>  Wed, 26 Feb 2025 14:23:56 +0800

=== debian/control ===
--- 
+++ 
@@ -1,7 +1,7 @@
 Source: tinycbor
 Section: utils
 Priority: optional
-Standards-Version: 4.7.0
+Standards-Version: 4.7.1
 Maintainer: Shengqi Chen <harry@debian.org>
 Build-Depends:
  debhelper-compat (= 13),
@@ -19,6 +19,7 @@
 Package: libtinycbor0.6
 Section: libs
 Architecture: any
+Multi-Arch: same
 Depends: ${misc:Depends}, ${shlibs:Depends}
 Suggests: tinycbor-utils
 Description: Concise Binary Object Representation (CBOR) library
@@ -31,6 +32,7 @@
 Package: libtinycbor-dev
 Section: libdevel
 Architecture: any
+Multi-Arch: same
 Depends: ${misc:Depends}, libtinycbor0.6 (= ${binary:Version})
 Description: Concise Binary Object Representation (CBOR) library (development files)
  TinyCBOR library is a small CBOR encoder and decoder library,

=== debian/rules ===
--- 
+++ 
@@ -24,7 +24,7 @@
 
 override_dh_auto_test:
 ifeq (,$(filter, nocheck,$(DEB_BUILD_OPTIONS)))
-	@echo 'blhc: ignore-line-regexp: .*(qt|Qt).*'
+	@echo 'blhc: ignore-line-regexp: .*(qt|Qt|tst).*'
 	$(MAKE) check
 endif

## tinycbor 0.6.1

=== Makefile ===
--- 
+++ 
@@ -64,20 +64,6 @@
 VERSION = $(shell cat $(SRCDIR)VERSION)
 SOVERSION = $(shell cut -f1-2 -d. $(SRCDIR)VERSION)
 PACKAGE = tinycbor-$(VERSION)
-
-# Check that QMAKE is Qt 5
-ifeq ($(origin QMAKE),file)
-  check_qmake = $(strip $(shell $(1) -query QT_VERSION 2>/dev/null | cut -b1))
-  ifneq ($(call check_qmake,$(QMAKE)),5)
-    QMAKE := qmake -qt5
-    ifneq ($(call check_qmake,$(QMAKE)),5)
-      QMAKE := qmake-qt5
-      ifneq ($(call check_qmake,$(QMAKE)),5)
-        QMAKE := @echo >&2 $(MAKEFILE): Cannot find a Qt 5 qmake; false
-      endif
-    endif
-  endif
-endif
 
 -include .config
 
@@ -134,7 +120,7 @@
 	TESTARGS=-silent $(MAKE) -f $(MAKEFILE) -s check
 configure: .config
 .config: Makefile.configure
-	$(MAKE) -f $(SRCDIR)Makefile.configure OUT='>&9' configure 9> $@
+	$(MAKE) -f $(SRCDIR)Makefile.configure OUT='$@' configure
 
 lib/libtinycbor-freestanding.a: $(TINYCBOR_FREESTANDING_SOURCES:.c=.o)
 	@$(MKDIR) -p lib
@@ -236,10 +222,16 @@
 .SECONDARY:
 
 cflags := $(CPPFLAGS) -I$(SRCDIR)src
-cflags += -std=gnu99 $(CFLAGS) \
+cflags += -std=gnu99 $(CFLAGS)
+
+ifneq ($(DISABLE_WERROR),1)
+cflags += \
+	$(shell $(CC) -S -Werror -Wdiscarded-qualifiers -o - -xc /dev/null >/dev/null 2>&1 && echo -Werror=discarded-qualifiers) \
 	-Werror=incompatible-pointer-types \
 	-Werror=implicit-function-declaration \
 	-Werror=int-conversion
+endif
+
 %.o: %.c
 	@test -d $(@D) || $(MKDIR) $(@D)
 	$(CC) $(cflags) $($(basename $(notdir $@))_CCFLAGS) -c -o $@ $<

=== tools/Makefile ===
CFLAGS = -O2 -g
CPPFLAGS = -I../src
VPATH = cbordump:../src

all: ../bin ../bin/cbordump
../bin:
	@-mkdir ../bin

../bin/cbordump: cbordump.o cborparser.o cborparser_dup_string.o cbortojson.o cborerrorstrings.o cborpretty.o
	$(CC) -o $@ $^
	$(RM) $^

=== debian/changelog ===
tinycbor (0.6.1-1) unstable; urgency=medium

  * New upstream version 0.6.1.
  * d/patches: refresh, update patch to fix autopkgtest failure, update meta.
  * d/{control,rules}: replace jquery.js in docs by link, and add libjs-jquery
    in Suggests of libtinycbor-dev.
  * d/control: bump std-ver to 4.7.2 (no changes required).

 -- Shengqi Chen <harry@debian.org>  Thu, 10 Apr 2025 14:00:08 +0800

=== debian/control ===
--- 
+++ 
@@ -1,10 +1,11 @@
 Source: tinycbor
 Section: utils
 Priority: optional
-Standards-Version: 4.7.1
+Standards-Version: 4.7.2
 Maintainer: Shengqi Chen <harry@debian.org>
 Build-Depends:
  debhelper-compat (= 13),
+ dh-sequence-doxygen,
  dh-exec,
  doxygen,
  graphviz,
@@ -34,6 +35,7 @@
 Architecture: any
 Multi-Arch: same
 Depends: ${misc:Depends}, libtinycbor0.6 (= ${binary:Version})
+Suggests: libjs-jquery
 Description: Concise Binary Object Representation (CBOR) library (development files)
  TinyCBOR library is a small CBOR encoder and decoder library,
  optimized for very fast operation with very small footprint.

=== debian/rules ===
--- 
+++ 
@@ -34,3 +34,9 @@
 execute_after_dh_auto_build:
 	help2man --version-string=$(DEB_VERSION_UPSTREAM) --name="tinycbor Concise Binary Object Representation (CBOR) library" -N -o cbordump.1 bin/cbordump
 	help2man --version-string=$(DEB_VERSION_UPSTREAM) --name="tinycbor Concise Binary Object Representation (CBOR) library" -N -o tinycbor-json2cbor.1 bin/json2cbor
+
+override_dh_installdocs:
+ifeq (,$(filter, nodoc,$(DEB_BUILD_OPTIONS)))
+	dh_installdocs
+	dh_link -plibtinycbor-dev /usr/share/javascript/jquery/jquery.js usr/share/doc/libtinycbor-dev/html/jquery.js
+endif

=== debian/tests/control ===
Tests: upstream-test-suite
Restrictions: allow-stderr
Depends: @, build-essential, qt6-base-dev | qtbase5-dev

## tinycbor 7.0

=== CMakeLists.txt ===
# /****************************************************************************
# **
# ** Copyright (C) 2015 Intel Corporation
# **
# ** Permission is hereby granted, free of charge, to any person obtaining a copy
# ** of this software and associated documentation files (the "Software"), to deal
# ** in the Software without restriction, including without limitation the rights
# ** to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# ** copies of the Software, and to permit persons to whom the Software is
# ** furnished to do so, subject to the following conditions:
# **
# ** The above copyright notice and this permission notice shall be included in
# ** all copies or substantial portions of the Software.
# **
# ** THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# ** IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# ** FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# ** AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# ** LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# ** OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
# ** THE SOFTWARE.
# **
# ****************************************************************************/

cmake_minimum_required(VERSION 3.10)

project(tinycbor LANGUAGES C CXX VERSION 7.0)

# Set path to additional cmake scripts
set(CMAKE_MODULE_PATH ${PROJECT_SOURCE_DIR}/cmake ${CMAKE_MODULE_PATH})

set(TARGETS_EXPORT_NAME "TinyCBOR-targets")

option(WITH_FLOATING_POINT "Use floating point code in TinyCBOR" ON)
option(WITH_FREESTANDING "Compile TinyCBOR in C freestanding mode" OFF)
if(WITH_FLOATING_POINT AND NOT WITH_FREESTANDING)
  option(WITH_CBOR2JSON "Compile code to convert from CBOR to JSON" ON)
  option(BUILD_EXAMPLES "Compile the TinyCBOR examples" OFF)
  option(BUILD_TOOLS "Compile the TinyCBOR tools" ON)
endif()

# Include additional modules that are used unconditionally
include(GNUInstallDirs)
include(GenerateExportHeader)
include(CheckLinkerFlag)
include(CheckSymbolExists)

add_library(tinycbor
  src/cborencoder.c
  src/cborencoder_close_container_checked.c
  src/cborerrorstrings.c
  src/cborparser.c
  src/cborpretty.c
  src/cborvalidation.c
  src/cbor.h
)
if(WITH_FREESTANDING)
  target_compile_options(tinycbor PUBLIC
    $<$<NOT:$<CXX_COMPILER_ID:MSVC>>:-ffreestanding>
  )
else()
  target_sources(tinycbor PRIVATE
    src/cborparser_dup_string.c
    src/cborpretty_stdio.c
  )
  if(WITH_CBOR2JSON)
    target_sources(tinycbor PRIVATE
      src/cbortojson.c
    )
  endif()
endif()
if(WITH_FLOATING_POINT)
  target_sources(tinycbor PRIVATE
    src/cborencoder_float.c
    src/cborparser_float.c
  )
  if(NOT WIN32)
    target_link_libraries(tinycbor m)
  endif()
else()
  target_compile_definitions(tinycbor PUBLIC CBOR_NO_FLOATING_POINT)
endif()

set_target_properties(tinycbor PROPERTIES
  # Force this library to link as C and compile as C99, to ensure we
  # don't use something of a newer language level.
  LINKER_LANGUAGE C
  C_EXTENSIONS OFF
  C_STANDARD 99

  # Set version and output name
  VERSION "0.${PROJECT_VERSION}"
  SOVERSION "0"
)
if(BUILD_SHARED_LIBS)
  set_target_properties(tinycbor PROPERTIES C_VISIBILITY_PRESET hidden)

  # Check if the linker supports "-z defs" (a.k.a "--no-undefined")
  check_linker_flag(C "-Wl,-z,defs" HAVE_NO_UNDEFINED)
  if(HAVE_NO_UNDEFINED)
    target_link_options(tinycbor PRIVATE "-Wl,-z,defs")
  endif()
else()
  target_compile_definitions(tinycbor PUBLIC CBOR_STATIC_DEFINE)
endif()

# Enable warnings
target_compile_options(tinycbor PRIVATE
  $<$<CXX_COMPILER_ID:MSVC>:-W3>
  $<$<NOT:$<CXX_COMPILER_ID:MSVC>>:
    -Wall -Wextra
    -Werror=format-security
    -Werror=incompatible-pointer-types
    -Werror=implicit-function-declaration
    -Werror=int-conversion
  >
)

# Generate export macros
generate_export_header(tinycbor
  BASE_NAME "cbor"
  EXPORT_MACRO_NAME "CBOR_API"
  EXPORT_FILE_NAME "tinycbor-export.h"
)

# Generate version header
configure_file(src/tinycbor-version.h.in tinycbor-version.h)

# Generate pkgconfig file
configure_file(tinycbor.pc.in tinycbor.pc @ONLY)

# Check for open_memstream and store the result in HAVE_OPEN_MEMSTREAM
check_symbol_exists(open_memstream stdio.h HAVE_OPEN_MEMSTREAM)
check_symbol_exists(funopen stdio.h HAVE_OPEN_FUNOPEN)
check_symbol_exists(fopencookie stdio.h HAVE_OPEN_FOPENCOOKIE)

if(NOT HAVE_OPEN_MEMSTREAM)
  if (HAVE_OPEN_FUNOPEN)
    message(STATUS "implementing open_memstream using funopen()")
    target_compile_definitions(tinycbor PRIVATE HAVE_OPEN_FUNOPEN)
    target_sources(tinycbor PRIVATE src/open_memstream.c)
  elseif (HAVE_OPEN_FOPENCOOKIE)
    message(STATUS "implementing open_memstream using fopencookie()")
    target_compile_definitions(tinycbor PRIVATE HAVE_OPEN_FOPENCOOKIE)
    target_sources(tinycbor PRIVATE src/open_memstream.c)
  else()
    target_compile_definitions(tinycbor PRIVATE WITHOUT_OPEN_MEMSTREAM)
    message(WARNING "funopen and fopencookie unavailable, open_memstream can not be implemented and conversion to JSON will not work properly!")
  endif()
endif()

target_include_directories(tinycbor
  PUBLIC "$<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/src>"
  PUBLIC "$<BUILD_INTERFACE:${PROJECT_BINARY_DIR}>"
  PUBLIC "$<INSTALL_INTERFACE:${CMAKE_INSTALL_INCLUDEDIR}>"
)

install(FILES
  ${PROJECT_SOURCE_DIR}/src/cbor.h
  ${PROJECT_BINARY_DIR}/tinycbor-version.h
  ${PROJECT_BINARY_DIR}/tinycbor-export.h
  DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}/tinycbor
)
install(FILES
  ${CMAKE_BINARY_DIR}/tinycbor.pc
  DESTINATION ${CMAKE_INSTALL_LIBDIR}/pkgconfig
)
install(
  TARGETS tinycbor
  EXPORT "${TARGETS_EXPORT_NAME}"
  ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR}   # import library
  LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}   # .so files are libraries
  RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR}   # .dll files are binaries
  INCLUDES DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}  # this does not actually install anything (but used by downstream projects)
)

set(PROJECT_LIBRARIES TinyCBOR)
include(PackageConfig)

if(BUILD_EXAMPLES)
  add_subdirectory(examples)
endif()
if(BUILD_TESTING)
  enable_testing()
  add_subdirectory(tests)
endif()
if(BUILD_TOOLS)
  add_subdirectory(tools)
endif()

=== examples/CMakeLists.txt ===
# Copyright (C) 2025 Intel Corporation
# SPDX-License-Identifier: MIT
include(TinyCBORHelpers)

tinycbor_add_executable(simplereader simplereader.c)

=== tests/CMakeLists.txt ===
# Copyright (C) 2025 Intel Corporation
# SPDX-License-Identifier: MIT
include(TinyCBORHelpers)
add_subdirectory(c90)

if(WITH_FREESTANDING OR NOT WITH_FLOATING_POINT)
  return()
endif()

find_package(Qt6 COMPONENTS Core Test)
if(Qt6_FOUND)
  set(CMAKE_CXX_STANDARD 20)
  set(CMAKE_AUTOMOC ON)
  add_subdirectory(cpp)
  add_subdirectory(encoder)
  add_subdirectory(parser)
  if(WITH_CBOR2JSON)
    add_subdirectory(tojson)
  endif()
endif()

=== tools/CMakeLists.txt ===
# Copyright (C) 2025 Intel Corporation
# SPDX-License-Identifier: MIT
include(TinyCBORHelpers)
add_subdirectory(cbordump)
add_subdirectory(json2cbor)

=== tests/c90/CMakeLists.txt ===
# Copyright (C) 2025 Intel Corporation
# SPDX-License-Identifier: MIT
tinycbor_add_test(tst_c90 tst_c90.c)
set_target_properties(tst_c90 PROPERTIES
  LINKER_LANGUAGE C
  C_STANDARD 90
  C_STANDARD_REQUIRED ON
)

=== tests/cpp/CMakeLists.txt ===
# Copyright (C) 2025 Intel Corporation
# SPDX-License-Identifier: MIT

tinycbor_add_qtest(tst_cpp tst_cpp.cpp)

=== tests/encoder/CMakeLists.txt ===
# Copyright (C) 2025 Intel Corporation
# SPDX-License-Identifier: MIT
tinycbor_add_qtest(tst_encoder tst_encoder.cpp)

=== tests/parser/CMakeLists.txt ===
# Copyright (C) 2025 Intel Corporation
# SPDX-License-Identifier: MIT
tinycbor_add_qtest(tst_parser tst_parser.cpp)

=== tests/tojson/CMakeLists.txt ===
# Copyright (C) 2025 Intel Corporation
# SPDX-License-Identifier: MIT
tinycbor_add_qtest(tst_tojson tst_tojson.cpp)

=== tools/cbordump/CMakeLists.txt ===
# Copyright (C) 2025 Intel Corporation
# SPDX-License-Identifier: MIT
if(NOT WIN32)
  tinycbor_add_executable(cbordump cbordump.c)
  install(TARGETS cbordump)
endif()

=== tools/json2cbor/CMakeLists.txt ===
# Copyright (C) 2025 Intel Corporation
# SPDX-License-Identifier: MIT
include(FindPkgConfig)
pkg_check_modules(LIBCJSON libcjson)
if(LIBCJSON_FOUND)
  tinycbor_add_executable(json2cbor json2cbor.c)
  target_include_directories(json2cbor SYSTEM PUBLIC ${LIBCJSON_INCLUDE_DIRS})
  target_link_libraries(json2cbor ${LIBCJSON_LIBRARIES})
endif()

=== debian/changelog ===
tinycbor (7.0-1) unstable; urgency=medium

  * d/watch: switch to version 5.
  * New upstream version 7.0.
    + d/patches: refresh existing patches.
    + d/: adapt to new cmake build scripts.
    + d/: change SONAME to libtinycbor0.
    + d/symbols: add new symbols for libtinycbor0.
  * d/control:
    + bump std-ver to 4.7.3 (no changes needed).
    + add qt6-base-dev for dh_auto_test.
  * d/tests: fix upstream-test-suite.

 -- Shengqi Chen <harry@debian.org>  Tue, 24 Feb 2026 16:15:26 +0800

=== debian/control ===
--- 
+++ 
@@ -1,23 +1,24 @@
 Source: tinycbor
 Section: utils
-Priority: optional
-Standards-Version: 4.7.2
+Standards-Version: 4.7.3
 Maintainer: Shengqi Chen <harry@debian.org>
 Build-Depends:
  debhelper-compat (= 13),
- dh-sequence-doxygen,
+ cmake,
+ ninja-build,
  dh-exec,
- doxygen,
- graphviz,
- help2man,
  libcjson-dev,
- qtbase5-dev
+ pkgconf,
+ qt6-base-dev <!nocheck>,
+ dh-sequence-doxygen <!nodoc>,
+ doxygen <!nodoc>,
+ graphviz <!nodoc>,
+ help2man <!nodoc>,
 Homepage: https://github.com/intel/tinycbor
 Vcs-Git: https://salsa.debian.org/harry/tinycbor.git
 Vcs-Browser: https://salsa.debian.org/harry/tinycbor
-Rules-Requires-Root: no
 
-Package: libtinycbor0.6
+Package: libtinycbor0
 Section: libs
 Architecture: any
 Multi-Arch: same
@@ -34,7 +35,7 @@
 Section: libdevel
 Architecture: any
 Multi-Arch: same
-Depends: ${misc:Depends}, libtinycbor0.6 (= ${binary:Version})
+Depends: ${misc:Depends}, libtinycbor0 (= ${binary:Version})
 Suggests: libjs-jquery
 Description: Concise Binary Object Representation (CBOR) library (development files)
  TinyCBOR library is a small CBOR encoder and decoder library,
@@ -45,7 +46,7 @@
 
 Package: tinycbor-utils
 Architecture: any
-Depends: ${misc:Depends}, ${shlibs:Depends}, libtinycbor0.6 (= ${binary:Version})
+Depends: ${misc:Depends}, ${shlibs:Depends}, libtinycbor0 (= ${binary:Version})
 Description: Concise Binary Object Representation (CBOR) library (utilities)
  TinyCBOR library is a small CBOR encoder and decoder library,
  optimized for very fast operation with very small footprint.

=== debian/rules ===
#!/usr/bin/make -f

export DEB_BUILD_MAINT_OPTIONS = hardening=+all
DPKG_EXPORT_BUILDFLAGS = 1

include /usr/share/dpkg/buildflags.mk
include /usr/share/dpkg/pkg-info.mk

#TARGET_DIR = $(CURDIR)/debian/tmp/usr
#TARGET_LIBDIR = $(TARGET_DIR)/lib/$(DEB_HOST_MULTIARCH)
BUILDDIR = $(CURDIR)/build

BUILD_TESTING=OFF
ifeq (,$(filter, nocheck,$(DEB_BUILD_OPTIONS)))
BUILD_TESTING=ON
endif

%:
	dh $@ -S cmake+ninja --builddirectory $(BUILDDIR)

override_dh_auto_configure:
	dh_auto_configure -- -DBUILD_SHARED_LIBS=ON -DBUILD_TESTING=$(BUILD_TESTING)

override_dh_auto_test:
ifeq ($(BUILD_TESTING),ON)
	dh_auto_test
endif

execute_after_dh_auto_build:
	help2man --version-string=$(DEB_VERSION_UPSTREAM) --name="tinycbor Concise Binary Object Representation (CBOR) library" -N -o cbordump.1 $(BUILDDIR)/tools/cbordump/cbordump
	help2man --version-string=$(DEB_VERSION_UPSTREAM) --name="tinycbor Concise Binary Object Representation (CBOR) library" -N -o tinycbor-json2cbor.1 $(BUILDDIR)/tools/json2cbor/json2cbor

override_dh_installdocs:
ifeq (,$(filter, nodoc,$(DEB_BUILD_OPTIONS)))
	cd src && VERSION=$(DEB_VERSION_UPSTREAM) doxygen ../Doxyfile
	dh_installdocs
	dh_link -plibtinycbor-dev /usr/share/javascript/jquery/jquery.js usr/share/doc/libtinycbor-dev/html/jquery.js
endif

=== debian/tests/control ===
Tests: upstream-test-suite
Restrictions: allow-stderr
Depends: @, build-essential, qt6-base-dev, cmake, ninja-build

=== debian/watch ===
Version: 5
Template: GitHub
Owner: intel
Project: tinycbor
